## libyuv 0.0~git20220617.e906ba9

=== CMakeLists.txt ===
# CMakeLists for libyuv
# Originally created for "roxlu build system" to compile libyuv on windows
# Run with -DTEST=ON to build unit tests

PROJECT ( YUV C CXX )	# "C" is required even for C++ projects
CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )
OPTION( TEST "Built unit tests" OFF )

SET ( ly_base_dir	${PROJECT_SOURCE_DIR} )
SET ( ly_src_dir	${ly_base_dir}/source )
SET ( ly_inc_dir	${ly_base_dir}/include )
SET ( ly_tst_dir	${ly_base_dir}/unit_test )
SET ( ly_lib_name	yuv )
SET ( ly_lib_static	${ly_lib_name} )
SET ( ly_lib_shared	${ly_lib_name}_shared )

FILE ( GLOB_RECURSE	ly_source_files ${ly_src_dir}/*.cc )
LIST ( SORT			ly_source_files )

FILE ( GLOB_RECURSE	ly_unittest_sources ${ly_tst_dir}/*.cc )
LIST ( SORT			ly_unittest_sources )

INCLUDE_DIRECTORIES( BEFORE ${ly_inc_dir} )

# this creates the static library (.a)
ADD_LIBRARY				( ${ly_lib_static} STATIC ${ly_source_files} )

# this creates the shared library (.so)
ADD_LIBRARY				( ${ly_lib_shared} SHARED ${ly_source_files} )
SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES OUTPUT_NAME "${ly_lib_name}" )
SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES PREFIX "lib" )

# this creates the conversion tool
ADD_EXECUTABLE			( yuvconvert ${ly_base_dir}/util/yuvconvert.cc )
TARGET_LINK_LIBRARIES	( yuvconvert ${ly_lib_static} )


INCLUDE ( FindJPEG )
if (JPEG_FOUND)
  include_directories( ${JPEG_INCLUDE_DIR} )
  target_link_libraries( yuvconvert ${JPEG_LIBRARY} )
  add_definitions( -DHAVE_JPEG )
endif()

if(TEST)
  find_library(GTEST_LIBRARY gtest)
  if(GTEST_LIBRARY STREQUAL "GTEST_LIBRARY-NOTFOUND")
    set(GTEST_SRC_DIR /usr/src/gtest CACHE STRING "Location of gtest sources")
    if(EXISTS ${GTEST_SRC_DIR}/src/gtest-all.cc)
      message(STATUS "building gtest from sources in ${GTEST_SRC_DIR}")
      set(gtest_sources ${GTEST_SRC_DIR}/src/gtest-all.cc)
      add_library(gtest STATIC ${gtest_sources})
      include_directories(${GTEST_SRC_DIR})
      include_directories(${GTEST_SRC_DIR}/include)
      set(GTEST_LIBRARY gtest)
    else()
      message(FATAL_ERROR "TEST is set but unable to find gtest library")
    endif()
  endif()

  add_executable(libyuv_unittest ${ly_unittest_sources})
  target_link_libraries(libyuv_unittest ${ly_lib_name} ${GTEST_LIBRARY})
  find_library(PTHREAD_LIBRARY pthread)
  if(NOT PTHREAD_LIBRARY STREQUAL "PTHREAD_LIBRARY-NOTFOUND")
    target_link_libraries(libyuv_unittest pthread)
  endif()
  if (JPEG_FOUND)
    target_link_libraries(libyuv_unittest ${JPEG_LIBRARY})
  endif()

  if(NACL AND NACL_LIBC STREQUAL "newlib")
    target_link_libraries(libyuv_unittest glibc-compat)
  endif()
endif()


# install the conversion tool, .so, .a, and all the header files
INSTALL ( PROGRAMS ${CMAKE_BINARY_DIR}/yuvconvert			DESTINATION bin )
INSTALL ( TARGETS ${ly_lib_static}						DESTINATION lib )
INSTALL ( TARGETS ${ly_lib_shared} LIBRARY				DESTINATION lib RUNTIME DESTINATION bin )
INSTALL ( DIRECTORY ${PROJECT_SOURCE_DIR}/include/		DESTINATION include )

# create the .deb and .rpm packages using cpack
INCLUDE ( CM_linux_packages.cmake )

## libyuv 0.0~git20220104.b91df1a

=== debian/changelog ===
libyuv (0.0~git20220104.b91df1a-2) unstable; urgency=medium

  * debian/control: Correctly mark package libyuv-dev as in
    section: libdevel.

 -- Boyuan Yang <byang@debian.org>  Wed, 23 Feb 2022 10:15:09 -0500

libyuv (0.0~git20220104.b91df1a-1) unstable; urgency=medium

  * New upstream snapshot 20220104 (version 1807).
  * debian/libyuv0.shlibs: Tighten version requirement to latest.

 -- Boyuan Yang <byang@debian.org>  Fri, 07 Jan 2022 17:06:29 -0500

libyuv (0.0~git20211210.fdc7195-1) unstable; urgency=medium

  * New upstream snapshot 20211210 (version 1806).
  * debian/libyuv0.shlibs: Tighten version requirement to latest.

 -- Boyuan Yang <byang@debian.org>  Sat, 11 Dec 2021 00:11:16 -0500

libyuv (0.0~git20211126.63ce1d0-1) unstable; urgency=medium

  * New upstream snapshot 20211126 (version 1805).
  * debian/libyuv0.shlibs: Tighten version requirement to latest.
  * debian/patches/0001: Try to automatically parse upstream version.
  * debian/control: Let libyuv0 Conflicts+Replaces+Provides libyuv
    to handle upstream CPack-generated deb packages.

 -- Boyuan Yang <byang@debian.org>  Sat, 04 Dec 2021 18:12:55 -0500

libyuv (0.0~git20210909.ed5a9c8-1) unstable; urgency=medium

  * Initial release.

 -- Boyuan Yang <byang@debian.org>  Mon, 23 Aug 2021 08:58:59 -0400

=== debian/control ===
Source: libyuv
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libjpeg-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://chromium.googlesource.com/libyuv/libyuv/
Vcs-Git: https://salsa.debian.org/debian/libyuv.git
Vcs-Browser: https://salsa.debian.org/debian/libyuv

Package: libyuv-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libyuv0 (= ${binary:Version}),
 ${misc:Depends},
Description: Library for YUV scaling (development files)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides the development files.

Package: libyuv-utils
Architecture: any
Depends:
 libyuv0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library for YUV scaling (utilities)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides utilities provided by the library, including
 yuvconvert.

Package: libyuv0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 libyuv,
Conflicts:
 libyuv,
Replaces:
 libyuv,
Description: Library for YUV scaling (shared library)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides the shared library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND =

%:
	dh $@

# https://github.com/archlinux/svntogit-community/blob/packages/libyuv/trunk/PKGBUILD
execute_before_dh_auto_configure:
	sed -i 's|yuvconvert $${JPEG_LIBRARY}|$${ly_lib_shared} $${JPEG_LIBRARY}|g' ./CMakeLists.txt

## libyuv 0.0~git20220617.e906ba9

=== debian/changelog ===
libyuv (0.0~git20220617.e906ba9-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 06 Jul 2022 13:40:58 -0700

libyuv (0.0~git20220617.e906ba9-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Tue, 28 Jun 2022 10:57:08 -0400

libyuv (0.0~git20220617.e906ba9-1) unstable; urgency=medium

  * New upstream snapshot 20220617 (version 1829)

 -- Boyuan Yang <byang@debian.org>  Sun, 19 Jun 2022 20:14:57 -0400

libyuv (0.0~git20220427.de71c67-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Thu, 05 May 2022 11:57:00 -0400

libyuv (0.0~git20220427.de71c67-1) unstable; urgency=medium

  * New upstream snapshot 20220427 (version 1823).
  * debian/libyuv0.shlibs: Tighten version requirement to latest.

 -- Boyuan Yang <byang@debian.org>  Fri, 29 Apr 2022 20:31:51 -0400

libyuv (0.0~git20220407.2ad7373-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Thu, 14 Apr 2022 11:10:15 -0400

libyuv (0.0~git20220407.2ad7373-1) unstable; urgency=medium

  * New upstream snapshot 20220407 (version 1818).
  * debian/libyuv0.shlibs: Tighten version requirement to latest.
  * debian/copyright: Update information.

 -- Boyuan Yang <byang@debian.org>  Mon, 11 Apr 2022 14:58:12 -0400

libyuv (0.0~git20220316.3aebf69-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Tue, 22 Mar 2022 19:08:58 -0400

libyuv (0.0~git20220316.3aebf69-1) unstable; urgency=medium

  * New upstream snapshot 20220316 (version 1813).
  * debian/libyuv0.shlibs: Tighten version requirement to latest.

 -- Boyuan Yang <byang@debian.org>  Wed, 16 Mar 2022 20:10:37 -0400

libyuv (0.0~git20220104.b91df1a-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Mon, 24 Jan 2022 15:39:46 -0500

=== debian/control ===
Source: libyuv
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Boyuan Yang <byang@debian.org>
Build-Depends: cmake, debhelper-compat (= 13), libjpeg-dev
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://chromium.googlesource.com/libyuv/libyuv/
Vcs-Git: https://salsa.debian.org/debian/libyuv.git
Vcs-Browser: https://salsa.debian.org/debian/libyuv

Package: libyuv-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libyuv0 (= ${binary:Version}), ${misc:Depends}
Description: Library for YUV scaling (development files)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides the development files.

Package: libyuv-utils
Architecture: any
Depends: libyuv0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Library for YUV scaling (utilities)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides utilities provided by the library, including
 yuvconvert.

Package: libyuv0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: libyuv
Conflicts: libyuv
Replaces: libyuv
Description: Library for YUV scaling (shared library)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides the shared library.

=== debian/rules ===
--- 
+++ 
@@ -18,3 +18,7 @@
 # https://github.com/archlinux/svntogit-community/blob/packages/libyuv/trunk/PKGBUILD
 execute_before_dh_auto_configure:
 	sed -i 's|yuvconvert $${JPEG_LIBRARY}|$${ly_lib_shared} $${JPEG_LIBRARY}|g' ./CMakeLists.txt
+
+# MX don't need no stinkin' dbgsyms
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

## libyuv 0.0~git20220809.9b17af9

=== debian/changelog ===
libyuv (0.0~git20220809.9b17af9-1ubuntu2) kinetic; urgency=medium

  * Add arm64 to the list of test blacklist archs: tests fail in Ubuntu
    but not in Debian and when running the testsuite for the previous
    version of the package (before the testsuite was enabled) it also fails.

 -- Steve Langasek <vorlon@debian.org>  Wed, 21 Sep 2022 17:41:12 +0000

libyuv (0.0~git20220809.9b17af9-1ubuntu1) kinetic; urgency=medium

  * debian/patches/0001-Revert-Merge-SplitRGB-fix-mcmodel-large-x86-and-
    Inte.patch: [PATCH] Revert "Merge/SplitRGB fix -mcmodel=large x86
    and.  Latest libyuv snapshot fails to build on amd64 and arm64 in
    Ubuntu with test regressions but not in Debian, not yet clear why.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 19 Sep 2022 10:26:03 -0700

libyuv (0.0~git20220809.9b17af9-1) unstable; urgency=medium

  * New upstream snapshot 20220809 (version 1838).
  * debian/libyuv0.shlibs: Tighten minimum version requirement.

 -- Boyuan Yang <byang@debian.org>  Thu, 11 Aug 2022 14:58:31 -0400

libyuv (0.0~git20220714.fe8c78b-2) unstable; urgency=medium

  * Disable tests on known broken architectures.

 -- Boyuan Yang <byang@debian.org>  Wed, 27 Jul 2022 17:56:05 -0400

libyuv (0.0~git20220714.fe8c78b-1) unstable; urgency=medium

  * New upstream snapshot 20220714 (version 1833)
  * debian/rules: Enable unit tests after build.
  * debian/control: Bump Standards-Version to 4.6.1.
  * debian/control: Add new build-dependency "googletest <!nocheck>".

 -- Boyuan Yang <byang@debian.org>  Thu, 21 Jul 2022 10:55:26 -0400

=== debian/control ===
Source: libyuv
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 googletest <!nocheck>,
 libjpeg-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://chromium.googlesource.com/libyuv/libyuv/
Vcs-Git: https://salsa.debian.org/debian/libyuv.git
Vcs-Browser: https://salsa.debian.org/debian/libyuv

Package: libyuv-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libyuv0 (= ${binary:Version}),
 ${misc:Depends},
Description: Library for YUV scaling (development files)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides the development files.

Package: libyuv-utils
Architecture: any
Depends:
 libyuv0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library for YUV scaling (utilities)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides utilities provided by the library, including
 yuvconvert.

Package: libyuv0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 libyuv,
Conflicts:
 libyuv,
Replaces:
 libyuv,
Description: Library for YUV scaling (shared library)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides the shared library.

=== debian/rules ===
--- 
+++ 
@@ -13,12 +13,30 @@
 export DEB_LDFLAGS_MAINT_APPEND =
 
 %:
-	dh $@
+	dh $@ --buildsystem=cmake
 
 # https://github.com/archlinux/svntogit-community/blob/packages/libyuv/trunk/PKGBUILD
 execute_before_dh_auto_configure:
 	sed -i 's|yuvconvert $${JPEG_LIBRARY}|$${ly_lib_shared} $${JPEG_LIBRARY}|g' ./CMakeLists.txt
 
-# MX don't need no stinkin' dbgsyms
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+  LIBYUV_TEST_FLAG := ON
+else
+  LIBYUV_TEST_FLAG := OFF
+endif
+
+# Known broken googletest
+ifneq (,$(filter $(DEB_HOST_ARCH), arm64 armel s390x powerpc ppc64 sparc64))
+  LIBYUV_TEST_FLAG = OFF
+endif
+
+override_dh_auto_configure:
+	dh_auto_configure -- \
+	    -DTEST=$(LIBYUV_TEST_FLAG) \
+	    $(NULL)
+
+execute_after_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	-find . -name libyuv_unittest
+	( exec $$(find . -name libyuv_unittest) )
+endif

## libyuv 0.0~git20221118.ea26d7a

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Run with -DTEST=ON to build unit tests
 
 PROJECT ( YUV C CXX )	# "C" is required even for C++ projects
-CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )
+CMAKE_MINIMUM_REQUIRED( VERSION 2.8.12 )
 OPTION( TEST "Built unit tests" OFF )
 
 SET ( ly_base_dir	${PROJECT_SOURCE_DIR} )
@@ -22,6 +22,10 @@
 
 INCLUDE_DIRECTORIES( BEFORE ${ly_inc_dir} )
 
+if(MSVC)
+  ADD_DEFINITIONS ( -D_CRT_SECURE_NO_WARNINGS )
+endif()
+
 # this creates the static library (.a)
 ADD_LIBRARY				( ${ly_lib_static} STATIC ${ly_source_files} )
 
@@ -29,13 +33,19 @@
 ADD_LIBRARY				( ${ly_lib_shared} SHARED ${ly_source_files} )
 SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES OUTPUT_NAME "${ly_lib_name}" )
 SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES PREFIX "lib" )
+if(WIN32)
+  SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES IMPORT_PREFIX "lib" )
+endif()
 
 # this creates the conversion tool
 ADD_EXECUTABLE			( yuvconvert ${ly_base_dir}/util/yuvconvert.cc )
 TARGET_LINK_LIBRARIES	( yuvconvert ${ly_lib_static} )
 
+# this creates the yuvconstants tool
+ADD_EXECUTABLE      ( yuvconstants ${ly_base_dir}/util/yuvconstants.c )
+TARGET_LINK_LIBRARIES  ( yuvconstants ${ly_lib_static} )
 
-INCLUDE ( FindJPEG )
+find_package ( JPEG )
 if (JPEG_FOUND)
   include_directories( ${JPEG_INCLUDE_DIR} )
   target_link_libraries( yuvconvert ${JPEG_LIBRARY} )
@@ -71,6 +81,12 @@
   if(NACL AND NACL_LIBC STREQUAL "newlib")
     target_link_libraries(libyuv_unittest glibc-compat)
   endif()
+
+  find_library(GFLAGS_LIBRARY gflags)
+  if(NOT GFLAGS_LIBRARY STREQUAL "GFLAGS_LIBRARY-NOTFOUND")
+    target_link_libraries(libyuv_unittest gflags)
+    add_definitions(-DLIBYUV_USE_GFLAGS)
+  endif()
 endif()

=== debian/changelog ===
libyuv (0.0~git20221118.ea26d7a-2~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 13 Dec 2022 16:42:12 -0800

libyuv (0.0~git20221118.ea26d7a-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Sat, 26 Nov 2022 14:41:16 -0500

libyuv (0.0~git20221118.ea26d7a-2) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 23 Nov 2022 13:44:31 -0500

libyuv (0.0~git20221118.ea26d7a-1) experimental; urgency=medium

  * New upstream snapshot 20221118.

 -- Boyuan Yang <byang@debian.org>  Sun, 20 Nov 2022 14:22:05 -0500

libyuv (0.0~git20221018.8084f0b-1) unstable; urgency=medium

  * New upstream snapshot 20221018.
    + Build yuvconstants tool.
  * debian/patches: Add CMakeLists.txt patch to ensure yuvconstants
    in installed after build.

 -- Boyuan Yang <byang@debian.org>  Tue, 18 Oct 2022 16:09:17 -0400

libyuv (0.0~git20220923.b9adaef-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 28 Sep 2022 16:07:45 -0400

libyuv (0.0~git20220923.b9adaef-1~exp1) experimental; urgency=medium

  * New upstream snapshot 20220923 (version 1845).
  * debian/libyuv0.shlibs: Tighten minimum version requirement.
  * debian/rules: Explicitly disable LTO. Enabling LTO will cause
    the following test to fail:
    - LibYUVPlanarTest.TestInterpolatePlane_16

 -- Boyuan Yang <byang@debian.org>  Sat, 24 Sep 2022 20:14:11 -0400

libyuv (0.0~git20220809.9b17af9-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Wed, 17 Aug 2022 15:10:03 -0400

=== debian/control ===
Source: libyuv
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Boyuan Yang <byang@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               googletest <!nocheck>,
               libjpeg-dev
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://chromium.googlesource.com/libyuv/libyuv/
Vcs-Git: https://salsa.debian.org/debian/libyuv.git
Vcs-Browser: https://salsa.debian.org/debian/libyuv

Package: libyuv-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libyuv0 (= ${binary:Version}), ${misc:Depends}
Description: Library for YUV scaling (development files)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides the development files.

Package: libyuv-utils
Architecture: any
Depends: libyuv0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Library for YUV scaling (utilities)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides utilities provided by the library, including
 yuvconvert.

Package: libyuv0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: libyuv
Conflicts: libyuv
Replaces: libyuv
Description: Library for YUV scaling (shared library)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides the shared library.

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # export DH_VERBOSE=1
 
 # see FEATURE AREAS in dpkg-buildflags(1)
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 
 # see ENVIRONMENT in dpkg-buildflags(1)
 # package maintainers to append CFLAGS
@@ -26,7 +26,7 @@
 endif
 
 # Known broken googletest
-ifneq (,$(filter $(DEB_HOST_ARCH), arm64 armel s390x powerpc ppc64 sparc64))
+ifneq (,$(filter $(DEB_HOST_ARCH), armel s390x powerpc ppc64 sparc64))
   LIBYUV_TEST_FLAG = OFF
 endif
 
@@ -40,3 +40,7 @@
 	-find . -name libyuv_unittest
 	( exec $$(find . -name libyuv_unittest) )
 endif
+
+# No dbgsym packages:
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

## libyuv 0.0~git20230104.6e4b0ac

=== debian/changelog ===
libyuv (0.0~git20230104.6e4b0ac-1) unstable; urgency=medium

  * New upstream snapshot 20230104.

 -- Boyuan Yang <byang@debian.org>  Sat, 07 Jan 2023 11:07:37 -0500

libyuv (0.0~git20221206.610e0cd-1~exp1) experimental; urgency=medium

  * New upstream snapshot 20221206.

 -- Boyuan Yang <byang@debian.org>  Sun, 11 Dec 2022 14:54:16 -0500

## libyuv 0.0~git20230123.b2528b0

=== debian/changelog ===
libyuv (0.0~git20230123.b2528b0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Thu, 23 Feb 2023 19:30:11 -0500

libyuv (0.0~git20230123.b2528b0-1) unstable; urgency=medium

  * New upstream snapshot 20230123.

 -- Boyuan Yang <byang@debian.org>  Sun, 12 Feb 2023 16:42:22 -0500

libyuv (0.0~git20230104.6e4b0ac-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Wed, 25 Jan 2023 13:03:59 -0500

=== debian/control ===
Source: libyuv
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 googletest <!nocheck>,
 libjpeg-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://chromium.googlesource.com/libyuv/libyuv/
Vcs-Git: https://salsa.debian.org/debian/libyuv.git
Vcs-Browser: https://salsa.debian.org/debian/libyuv

Package: libyuv-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libyuv0 (= ${binary:Version}),
 ${misc:Depends},
Description: Library for YUV scaling (development files)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides the development files.

Package: libyuv-utils
Architecture: any
Depends:
 libyuv0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library for YUV scaling (utilities)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides utilities provided by the library, including
 yuvconvert.

Package: libyuv0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 libyuv,
Conflicts:
 libyuv,
Replaces:
 libyuv,
Description: Library for YUV scaling (shared library)
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.
 .
 This package provides the shared library.

## libyuv 0.0~git202401110.af6ac82

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 PROJECT ( YUV C CXX )	# "C" is required even for C++ projects
 CMAKE_MINIMUM_REQUIRED( VERSION 2.8.12 )
-OPTION( TEST "Built unit tests" OFF )
+OPTION( UNIT_TEST "Built unit tests" OFF )
 
 SET ( ly_base_dir	${PROJECT_SOURCE_DIR} )
 SET ( ly_src_dir	${ly_base_dir}/source )
@@ -37,6 +37,10 @@
   SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES IMPORT_PREFIX "lib" )
 endif()
 
+# this creates the cpuid tool
+ADD_EXECUTABLE      ( cpuid ${ly_base_dir}/util/cpuid.c )
+TARGET_LINK_LIBRARIES  ( cpuid ${ly_lib_static} )
+
 # this creates the conversion tool
 ADD_EXECUTABLE			( yuvconvert ${ly_base_dir}/util/yuvconvert.cc )
 TARGET_LINK_LIBRARIES	( yuvconvert ${ly_lib_static} )
@@ -48,14 +52,17 @@
 find_package ( JPEG )
 if (JPEG_FOUND)
   include_directories( ${JPEG_INCLUDE_DIR} )
-  target_link_libraries( yuvconvert ${JPEG_LIBRARY} )
+  target_link_libraries( ${ly_lib_shared} ${JPEG_LIBRARY} )
   add_definitions( -DHAVE_JPEG )
 endif()
 
-if(TEST)
+if(UNIT_TEST)
   find_library(GTEST_LIBRARY gtest)
   if(GTEST_LIBRARY STREQUAL "GTEST_LIBRARY-NOTFOUND")
     set(GTEST_SRC_DIR /usr/src/gtest CACHE STRING "Location of gtest sources")
+    if (CMAKE_CROSSCOMPILING)
+      set(GTEST_SRC_DIR third_party/googletest/src/googletest)
+    endif()
     if(EXISTS ${GTEST_SRC_DIR}/src/gtest-all.cc)
       message(STATUS "building gtest from sources in ${GTEST_SRC_DIR}")
       set(gtest_sources ${GTEST_SRC_DIR}/src/gtest-all.cc)
@@ -64,7 +71,7 @@
       include_directories(${GTEST_SRC_DIR}/include)
       set(GTEST_LIBRARY gtest)
     else()
-      message(FATAL_ERROR "TEST is set but unable to find gtest library")
+      message(FATAL_ERROR "UNIT_TEST is set but unable to find gtest library")
     endif()
   endif()

=== debian/changelog ===
libyuv (0.0~git202401110.af6ac82-1) unstable; urgency=medium

  * New upstream snapshot 20240110.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Tue, 16 Jan 2024 07:12:33 -0500

libyuv (0.0~git20231118.e6d5adb-1) unstable; urgency=medium

  * New upstream release 20231118.

 -- Boyuan Yang <byang@debian.org>  Sun, 26 Nov 2023 14:27:42 -0500

libyuv (0.0~git20230907.cbfb661-1) unstable; urgency=medium

  * New upstream snapshot 20230907.

 -- Boyuan Yang <byang@debian.org>  Fri, 15 Sep 2023 14:06:12 -0400

libyuv (0.0~git20230616.a366ad7-2) unstable; urgency=medium

  [ Vladimir Petko ]
  * debian/tests/: Add autopkgtest using upstream testsuite.

 -- Boyuan Yang <byang@debian.org>  Fri, 15 Sep 2023 04:41:31 -0400

libyuv (0.0~git20230616.a366ad7-1) unstable; urgency=medium

  * New upstream snapshot 20230616.
  * debian/rules: Update UNIT_TEST flag name.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Tue, 20 Jun 2023 13:44:03 -0400

=== debian/rules ===
--- 
+++ 
@@ -32,7 +32,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-	    -DTEST=$(LIBYUV_TEST_FLAG) \
+	    -DUNIT_TEST=$(LIBYUV_TEST_FLAG) \
 	    $(NULL)
 
 execute_after_dh_auto_test:
@@ -40,7 +40,3 @@
 	-find . -name libyuv_unittest
 	( exec $$(find . -name libyuv_unittest) )
 endif
-
-# No dbgsym packages:
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4
opts="mode=git" \
 https://chromium.googlesource.com/libyuv/libyuv \
 HEAD debian uupdate

## libyuv 0.0.1888.20240509

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,8 +14,54 @@
 SET ( ly_lib_static	${ly_lib_name} )
 SET ( ly_lib_shared	${ly_lib_name}_shared )
 
-FILE ( GLOB_RECURSE	ly_source_files ${ly_src_dir}/*.cc )
-LIST ( SORT			ly_source_files )
+# We cannot use GLOB here since we want to be able to separate out files that
+# need particular flags to enable architecture extensions like AArch64's SVE.
+# TODO: More of these files could be separated out for different architectures.
+SET ( ly_common_source_files
+  ${ly_src_dir}/compare.cc
+  ${ly_src_dir}/compare_common.cc
+  ${ly_src_dir}/compare_gcc.cc
+  ${ly_src_dir}/compare_msa.cc
+  ${ly_src_dir}/compare_win.cc
+  ${ly_src_dir}/convert_argb.cc
+  ${ly_src_dir}/convert.cc
+  ${ly_src_dir}/convert_from_argb.cc
+  ${ly_src_dir}/convert_from.cc
+  ${ly_src_dir}/convert_jpeg.cc
+  ${ly_src_dir}/convert_to_argb.cc
+  ${ly_src_dir}/convert_to_i420.cc
+  ${ly_src_dir}/cpu_id.cc
+  ${ly_src_dir}/mjpeg_decoder.cc
+  ${ly_src_dir}/mjpeg_validate.cc
+  ${ly_src_dir}/planar_functions.cc
+  ${ly_src_dir}/rotate_any.cc
+  ${ly_src_dir}/rotate_argb.cc
+  ${ly_src_dir}/rotate.cc
+  ${ly_src_dir}/rotate_common.cc
+  ${ly_src_dir}/rotate_gcc.cc
+  ${ly_src_dir}/rotate_lsx.cc
+  ${ly_src_dir}/rotate_msa.cc
+  ${ly_src_dir}/rotate_win.cc
+  ${ly_src_dir}/row_any.cc
+  ${ly_src_dir}/row_common.cc
+  ${ly_src_dir}/row_gcc.cc
+  ${ly_src_dir}/row_lasx.cc
+  ${ly_src_dir}/row_lsx.cc
+  ${ly_src_dir}/row_msa.cc
+  ${ly_src_dir}/row_rvv.cc
+  ${ly_src_dir}/row_win.cc
+  ${ly_src_dir}/scale_any.cc
+  ${ly_src_dir}/scale_argb.cc
+  ${ly_src_dir}/scale.cc
+  ${ly_src_dir}/scale_common.cc
+  ${ly_src_dir}/scale_gcc.cc
+  ${ly_src_dir}/scale_lsx.cc
+  ${ly_src_dir}/scale_msa.cc
+  ${ly_src_dir}/scale_rgb.cc
+  ${ly_src_dir}/scale_rvv.cc
+  ${ly_src_dir}/scale_uv.cc
+  ${ly_src_dir}/scale_win.cc
+  ${ly_src_dir}/video_common.cc)
 
 FILE ( GLOB_RECURSE	ly_unittest_sources ${ly_tst_dir}/*.cc )
 LIST ( SORT			ly_unittest_sources )
@@ -26,15 +72,56 @@
   ADD_DEFINITIONS ( -D_CRT_SECURE_NO_WARNINGS )
 endif()
 
+# Need to set PIC to allow creating shared libraries from object file libraries.
+SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
+
+# Build the set of objects that do not need to be compiled with flags to enable
+# particular architecture features.
+ADD_LIBRARY( ${ly_lib_name}_common_objects OBJECT ${ly_common_source_files} )
+SET(ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_common_objects>)
+
+if(NOT MSVC)
+  STRING(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" arch_lowercase)
+
+  if(arch_lowercase MATCHES "^arm" AND NOT arch_lowercase STREQUAL "arm64")
+    # Enable Arm Neon kernels.
+    ADD_DEFINITIONS(-DLIBYUV_NEON=1)
+    ADD_LIBRARY(${ly_lib_name}_neon OBJECT
+      ${ly_src_dir}/compare_neon.cc
+      ${ly_src_dir}/rotate_neon.cc
+      ${ly_src_dir}/row_neon.cc
+      ${ly_src_dir}/scale_neon.cc)
+    TARGET_COMPILE_OPTIONS(${ly_lib_name}_neon PRIVATE -mfpu=neon)
+    LIST(APPEND ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_neon>)
+  endif()
+
+  if(arch_lowercase STREQUAL "aarch64" OR arch_lowercase STREQUAL "arm64")
+    # Enable AArch64 Neon dot-product and i8mm kernels.
+    ADD_LIBRARY(${ly_lib_name}_neon64 OBJECT
+      ${ly_src_dir}/compare_neon64.cc
+      ${ly_src_dir}/rotate_neon64.cc
+      ${ly_src_dir}/row_neon64.cc
+      ${ly_src_dir}/scale_neon64.cc)
+    TARGET_COMPILE_OPTIONS(${ly_lib_name}_neon64 PRIVATE -march=armv8-a+dotprod+i8mm)
+    LIST(APPEND ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_neon64>)
+
+    # Enable AArch64 SVE kernels.
+    ADD_LIBRARY(${ly_lib_name}_sve OBJECT
+      ${ly_src_dir}/row_sve.cc)
+    TARGET_COMPILE_OPTIONS(${ly_lib_name}_sve PRIVATE -march=armv9-a+sve2)
+    LIST(APPEND ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_sve>)
+  endif()
+endif()
+
 # this creates the static library (.a)
-ADD_LIBRARY				( ${ly_lib_static} STATIC ${ly_source_files} )
+ADD_LIBRARY( ${ly_lib_static} STATIC ${ly_lib_parts})
 
 # this creates the shared library (.so)
-ADD_LIBRARY				( ${ly_lib_shared} SHARED ${ly_source_files} )
-SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES OUTPUT_NAME "${ly_lib_name}" )
-SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES PREFIX "lib" )
+ADD_LIBRARY( ${ly_lib_shared} SHARED ${ly_lib_parts})
+SET_TARGET_PROPERTIES( ${ly_lib_shared} PROPERTIES OUTPUT_NAME "${ly_lib_name}" )
+SET_TARGET_PROPERTIES( ${ly_lib_shared} PROPERTIES PREFIX "lib" )
 if(WIN32)
-  SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES IMPORT_PREFIX "lib" )
+  SET_TARGET_PROPERTIES( ${ly_lib_shared} PROPERTIES IMPORT_PREFIX "lib" )
 endif()
 
 # this creates the cpuid tool
@@ -59,10 +146,11 @@
 if(UNIT_TEST)
   find_library(GTEST_LIBRARY gtest)
   if(GTEST_LIBRARY STREQUAL "GTEST_LIBRARY-NOTFOUND")
-    set(GTEST_SRC_DIR /usr/src/gtest CACHE STRING "Location of gtest sources")
+    set(GTEST_SRC_DIR_DEFAULT /usr/src/gtest)
     if (CMAKE_CROSSCOMPILING)
-      set(GTEST_SRC_DIR third_party/googletest/src/googletest)
+      set(GTEST_SRC_DIR_DEFAULT ${CMAKE_SOURCE_DIR}/third_party/googletest/src/googletest)
     endif()
+    set(GTEST_SRC_DIR ${GTEST_SRC_DIR_DEFAULT} CACHE STRING "Location of gtest sources")
     if(EXISTS ${GTEST_SRC_DIR}/src/gtest-all.cc)
       message(STATUS "building gtest from sources in ${GTEST_SRC_DIR}")
       set(gtest_sources ${GTEST_SRC_DIR}/src/gtest-all.cc)

=== debian/changelog ===
libyuv (0.0.1888.20240509-4) unstable; urgency=medium

  * Really fix patch 0004 to fix the FTBFS on ARM architectures.

 -- Boyuan Yang <byang@debian.org>  Thu, 16 May 2024 11:41:02 -0400

libyuv (0.0.1888.20240509-3) unstable; urgency=medium

  * Revise patch 0004 to really fix the FTBFS.

 -- Boyuan Yang <byang@debian.org>  Tue, 14 May 2024 08:10:55 -0400

libyuv (0.0.1888.20240509-2) unstable; urgency=medium

  * d/p/0004-CMakeLists.txt-Do-not-enable-NEON-for-armel-armhf.patch:
    Do not enable NEON for armel to avoid FTBFS. Also do not enable NEON
    for armhf since Debian armhf does not guarantee it in the
    architecture baseline.

 -- Boyuan Yang <byang@debian.org>  Mon, 13 May 2024 23:42:13 -0400

libyuv (0.0.1888.20240509-1) unstable; urgency=medium

  * New upstream snapshot 20240509 (rev 1888).
  * Revise versioning scheme due to broken date in the last upload.
  * debian/watch: Adjust monitoring pretty rule accordingly.
  * debian/patches/0002-googletest: Dropped, use variable override
    in debian/rules instead.

 -- Boyuan Yang <byang@debian.org>  Mon, 13 May 2024 21:43:17 -0400

## libyuv 0.0.1888.20240607

=== debian/changelog ===
libyuv (0.0.1888.20240607-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Boyuan Yang <byang@debian.org>  Sat, 08 Jun 2024 18:52:58 -0400

=== debian/rules ===
--- 
+++ 
@@ -33,6 +33,7 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	    -DUNIT_TEST=$(LIBYUV_TEST_FLAG) \
+	    -DGTEST_SRC_DIR=/usr/src/googletest/googletest \
 	    $(NULL)
 
 execute_after_dh_auto_test:

## libyuv 0.0.1888.20240710

=== CMakeLists.txt ===
--- 
+++ 
@@ -110,6 +110,12 @@
       ${ly_src_dir}/row_sve.cc)
     TARGET_COMPILE_OPTIONS(${ly_lib_name}_sve PRIVATE -march=armv9-a+sve2)
     LIST(APPEND ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_sve>)
+
+    # Enable AArch64 SME kernels.
+    ADD_LIBRARY(${ly_lib_name}_sme OBJECT
+      ${ly_src_dir}/rotate_sme.cc)
+    TARGET_COMPILE_OPTIONS(${ly_lib_name}_sme PRIVATE -march=armv9-a+sme)
+    LIST(APPEND ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_sme>)
   endif()
 endif()

=== debian/changelog ===
libyuv (0.0.1888.20240710-3) unstable; urgency=medium

  * debian/rules: Disable tests on hppa as well due to broken support for
    big-endian architecture. (Closes: #1021606)

 -- Boyuan Yang <byang@debian.org>  Thu, 11 Jul 2024 10:33:57 -0400

libyuv (0.0.1888.20240710-2) unstable; urgency=medium

  * debian/patches/0004-Do-not-compile-AArch64-SME-kernels-for-now.patch:
    Do not compile AArch64 SME kernels for arm64 since the current GCC seems
    does not recognize feature modifier sme in '-march=armv9-a+sme'.
    This fixes FTBFS on arm64 architecture with GCC 13.

 -- Boyuan Yang <byang@debian.org>  Thu, 11 Jul 2024 00:10:31 -0400

libyuv (0.0.1888.20240710-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Boyuan Yang <byang@debian.org>  Wed, 10 Jul 2024 22:38:06 -0400

## libyuv 0.0.1888.20241107

=== CMakeLists.txt ===
# CMakeLists for libyuv
# Originally created for "roxlu build system" to compile libyuv on windows
# Run with -DTEST=ON to build unit tests

include(CheckCSourceCompiles)

project ( YUV C CXX )	# "C" is required even for C++ projects
cmake_minimum_required( VERSION 2.8.12 )
option( UNIT_TEST "Built unit tests" OFF )

set ( ly_base_dir	${PROJECT_SOURCE_DIR} )
set ( ly_src_dir	${ly_base_dir}/source )
set ( ly_inc_dir	${ly_base_dir}/include )
set ( ly_tst_dir	${ly_base_dir}/unit_test )
set ( ly_lib_name	yuv )
set ( ly_lib_static	${ly_lib_name} )
set ( ly_lib_shared	${ly_lib_name}_shared )

# We cannot use GLOB here since we want to be able to separate out files that
# need particular flags to enable architecture extensions like AArch64's SVE.
# TODO: More of these files could be separated out for different architectures.
set ( ly_common_source_files
  ${ly_src_dir}/compare.cc
  ${ly_src_dir}/compare_common.cc
  ${ly_src_dir}/compare_gcc.cc
  ${ly_src_dir}/compare_msa.cc
  ${ly_src_dir}/compare_win.cc
  ${ly_src_dir}/convert_argb.cc
  ${ly_src_dir}/convert.cc
  ${ly_src_dir}/convert_from_argb.cc
  ${ly_src_dir}/convert_from.cc
  ${ly_src_dir}/convert_jpeg.cc
  ${ly_src_dir}/convert_to_argb.cc
  ${ly_src_dir}/convert_to_i420.cc
  ${ly_src_dir}/cpu_id.cc
  ${ly_src_dir}/mjpeg_decoder.cc
  ${ly_src_dir}/mjpeg_validate.cc
  ${ly_src_dir}/planar_functions.cc
  ${ly_src_dir}/rotate_any.cc
  ${ly_src_dir}/rotate_argb.cc
  ${ly_src_dir}/rotate.cc
  ${ly_src_dir}/rotate_common.cc
  ${ly_src_dir}/rotate_gcc.cc
  ${ly_src_dir}/rotate_lsx.cc
  ${ly_src_dir}/rotate_msa.cc
  ${ly_src_dir}/rotate_win.cc
  ${ly_src_dir}/row_any.cc
  ${ly_src_dir}/row_common.cc
  ${ly_src_dir}/row_gcc.cc
  ${ly_src_dir}/row_lasx.cc
  ${ly_src_dir}/row_lsx.cc
  ${ly_src_dir}/row_msa.cc
  ${ly_src_dir}/row_rvv.cc
  ${ly_src_dir}/row_win.cc
  ${ly_src_dir}/scale_any.cc
  ${ly_src_dir}/scale_argb.cc
  ${ly_src_dir}/scale.cc
  ${ly_src_dir}/scale_common.cc
  ${ly_src_dir}/scale_gcc.cc
  ${ly_src_dir}/scale_lsx.cc
  ${ly_src_dir}/scale_msa.cc
  ${ly_src_dir}/scale_rgb.cc
  ${ly_src_dir}/scale_rvv.cc
  ${ly_src_dir}/scale_uv.cc
  ${ly_src_dir}/scale_win.cc
  ${ly_src_dir}/video_common.cc)

file ( GLOB_RECURSE	ly_unittest_sources ${ly_tst_dir}/*.cc )
list ( SORT			ly_unittest_sources )

include_directories( BEFORE ${ly_inc_dir} )

if(MSVC)
  add_definitions ( -D_CRT_SECURE_NO_WARNINGS )
endif()

# Need to set PIC to allow creating shared libraries from object file libraries.
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Build the set of objects that do not need to be compiled with flags to enable
# particular architecture features.
add_library( ${ly_lib_name}_common_objects OBJECT ${ly_common_source_files} )
set(ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_common_objects>)

if(NOT MSVC)
  string(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" arch_lowercase)

  if(arch_lowercase MATCHES "^arm" AND NOT arch_lowercase STREQUAL "arm64")
    # Enable Arm Neon kernels.
    add_definitions(-DLIBYUV_NEON=1)
    add_library(${ly_lib_name}_neon OBJECT
      ${ly_src_dir}/compare_neon.cc
      ${ly_src_dir}/rotate_neon.cc
      ${ly_src_dir}/row_neon.cc
      ${ly_src_dir}/scale_neon.cc)
    target_compile_options(${ly_lib_name}_neon PRIVATE -mfpu=neon)
    list(APPEND ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_neon>)
  endif()

  if(arch_lowercase STREQUAL "aarch64" OR arch_lowercase STREQUAL "arm64")
    # Enable AArch64 Neon dot-product and i8mm kernels.
    add_library(${ly_lib_name}_neon64 OBJECT
      ${ly_src_dir}/compare_neon64.cc
      ${ly_src_dir}/rotate_neon64.cc
      ${ly_src_dir}/row_neon64.cc
      ${ly_src_dir}/scale_neon64.cc)
    target_compile_options(${ly_lib_name}_neon64 PRIVATE -march=armv8-a+dotprod+i8mm)
    list(APPEND ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_neon64>)

    # Enable AArch64 SVE kernels.
    add_library(${ly_lib_name}_sve OBJECT
      ${ly_src_dir}/row_sve.cc)
    target_compile_options(${ly_lib_name}_sve PRIVATE -march=armv9-a+sve2)
    list(APPEND ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_sve>)

    set(OLD_CMAKE_REQURED_FLAGS ${CMAKE_REQUIRED_FLAGS})
    set(OLD_CMAKE_TRY_COMPILE_TARGET_TYPE ${CMAKE_TRY_COMPILE_TARGET_TYPE})
    set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -march=armv9-a+sme")
    set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
    # Check whether the compiler can compile SME functions; this fails
    # with Clang for Windows.
    check_c_source_compiles("
__arm_locally_streaming void func(void) { }
int main(void) { return 0; }
    " CAN_COMPILE_SME)
    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQURED_FLAGS})
    set(CMAKE_TRY_COMPILE_TARGET_TYPE ${OLD_CMAKE_TRY_COMPILE_TARGET_TYPE})

    if (CAN_COMPILE_SME)
      # Enable AArch64 SME kernels.
      add_library(${ly_lib_name}_sme OBJECT
        ${ly_src_dir}/rotate_sme.cc
        ${ly_src_dir}/row_sme.cc
        ${ly_src_dir}/scale_sme.cc)
      target_compile_options(${ly_lib_name}_sme PRIVATE -march=armv9-a+sme)
      list(APPEND ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_sme>)
    else()
      add_definitions(-DLIBYUV_DISABLE_SME)
    endif()
  endif()
endif()

# this creates the static library (.a)
add_library( ${ly_lib_static} STATIC ${ly_lib_parts})

# this creates the shared library (.so)
add_library( ${ly_lib_shared} SHARED ${ly_lib_parts})
set_target_properties( ${ly_lib_shared} PROPERTIES OUTPUT_NAME "${ly_lib_name}" )
set_target_properties( ${ly_lib_shared} PROPERTIES PREFIX "lib" )
if(WIN32)
  set_target_properties( ${ly_lib_shared} PROPERTIES IMPORT_PREFIX "lib" )
endif()

# this creates the cpuid tool
add_executable      ( cpuid ${ly_base_dir}/util/cpuid.c )
target_link_libraries  ( cpuid ${ly_lib_static} )

# this creates the conversion tool
add_executable			( yuvconvert ${ly_base_dir}/util/yuvconvert.cc )
target_link_libraries	( yuvconvert ${ly_lib_static} )

# this creates the yuvconstants tool
add_executable      ( yuvconstants ${ly_base_dir}/util/yuvconstants.c )
target_link_libraries  ( yuvconstants ${ly_lib_static} )

find_package ( JPEG )
if (JPEG_FOUND)
  include_directories( ${JPEG_INCLUDE_DIR} )
  target_link_libraries( ${ly_lib_shared} ${JPEG_LIBRARY} )
  add_definitions( -DHAVE_JPEG )
endif()

if(UNIT_TEST)
  find_library(GTEST_LIBRARY gtest)
  if(GTEST_LIBRARY STREQUAL "GTEST_LIBRARY-NOTFOUND")
    set(GTEST_SRC_DIR_DEFAULT /usr/src/gtest)
    if (CMAKE_CROSSCOMPILING)
      set(GTEST_SRC_DIR_DEFAULT ${CMAKE_SOURCE_DIR}/third_party/googletest/src/googletest)
    endif()
    set(GTEST_SRC_DIR ${GTEST_SRC_DIR_DEFAULT} CACHE STRING "Location of gtest sources")
    if(EXISTS ${GTEST_SRC_DIR}/src/gtest-all.cc)
      message(STATUS "building gtest from sources in ${GTEST_SRC_DIR}")
      set(gtest_sources ${GTEST_SRC_DIR}/src/gtest-all.cc)
      add_library(gtest STATIC ${gtest_sources})
      include_directories(${GTEST_SRC_DIR})
      include_directories(${GTEST_SRC_DIR}/include)
      set(GTEST_LIBRARY gtest)
    else()
      message(FATAL_ERROR "UNIT_TEST is set but unable to find gtest library")
    endif()
  endif()

  add_executable(libyuv_unittest ${ly_unittest_sources})
  target_link_libraries(libyuv_unittest ${ly_lib_name} ${GTEST_LIBRARY})
  find_library(PTHREAD_LIBRARY pthread)
  if(NOT PTHREAD_LIBRARY STREQUAL "PTHREAD_LIBRARY-NOTFOUND")
    target_link_libraries(libyuv_unittest pthread)
  endif()
  if (JPEG_FOUND)
    target_link_libraries(libyuv_unittest ${JPEG_LIBRARY})
  endif()

  if(NACL AND NACL_LIBC STREQUAL "newlib")
    target_link_libraries(libyuv_unittest glibc-compat)
  endif()

  find_library(GFLAGS_LIBRARY gflags)
  if(NOT GFLAGS_LIBRARY STREQUAL "GFLAGS_LIBRARY-NOTFOUND")
    target_link_libraries(libyuv_unittest gflags)
    add_definitions(-DLIBYUV_USE_GFLAGS)
  endif()
endif()


# install the conversion tool, .so, .a, and all the header files
install ( TARGETS yuvconvert DESTINATION bin )
install ( TARGETS ${ly_lib_static}						DESTINATION lib )
install ( TARGETS ${ly_lib_shared} LIBRARY DESTINATION lib RUNTIME DESTINATION bin ARCHIVE DESTINATION lib )
install ( DIRECTORY ${PROJECT_SOURCE_DIR}/include/		DESTINATION include )

# create the .deb and .rpm packages using cpack
include ( CM_linux_packages.cmake )

=== debian/changelog ===
libyuv (0.0.1888.20241107-1) unstable; urgency=medium

  * New upstream snapshot.
  * debian/control: Move package description to source package section.
  * debian/patches: Refresh patches.
  * debian/patches/0004-Do-not-compile-AArch64-SME-kernels-for-now.patch:
    Dropped for now to make a test build.

 -- Boyuan Yang <byang@debian.org>  Fri, 08 Nov 2024 08:31:45 -0500

=== debian/watch ===
version=4
#opts="mode=git,pretty=0.0.%cd.%h" \
opts="mode=git,pretty=0.0.1888.%cd" \
 https://chromium.googlesource.com/libyuv/libyuv \
 HEAD debian uupdate

## libyuv 0.0.1897.20241115

=== CMakeLists.txt ===
--- 
+++ 
@@ -113,7 +113,7 @@
     target_compile_options(${ly_lib_name}_sve PRIVATE -march=armv9-a+sve2)
     list(APPEND ly_lib_parts $<TARGET_OBJECTS:${ly_lib_name}_sve>)
 
-    set(OLD_CMAKE_REQURED_FLAGS ${CMAKE_REQUIRED_FLAGS})
+    set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
     set(OLD_CMAKE_TRY_COMPILE_TARGET_TYPE ${CMAKE_TRY_COMPILE_TARGET_TYPE})
     set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -march=armv9-a+sme")
     set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
@@ -123,7 +123,7 @@
 __arm_locally_streaming void func(void) { }
 int main(void) { return 0; }
     " CAN_COMPILE_SME)
-    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQURED_FLAGS})
+    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
     set(CMAKE_TRY_COMPILE_TARGET_TYPE ${OLD_CMAKE_TRY_COMPILE_TARGET_TYPE})
 
     if (CAN_COMPILE_SME)

=== debian/changelog ===
libyuv (0.0.1897.20241115-1aatgv1) unstable; urgency=medium

  * Build for m-privacy
  * Add RSBAC settings
  * debian/rules:
    - export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
    - export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
    - export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects

 -- Amon Ott <ao@m-privacy.de>  Thu, 21 Nov 2024 14:41:16 +0100

libyuv (0.0.1897.20241115-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Boyuan Yang <byang@debian.org>  Sat, 16 Nov 2024 17:39:22 -0500

=== debian/control ===
Source: libyuv
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 googletest ,
 libjpeg-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://chromium.googlesource.com/libyuv/libyuv/
Vcs-Git: https://salsa.debian.org/debian/libyuv.git
Vcs-Browser: https://salsa.debian.org/debian/libyuv
Description: Library for YUV scaling
 libyuv is an open source project that includes YUV scaling and
 conversion functionality.

Package: libyuv-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libyuv0 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package provides the development files.

Package: libyuv-utils
Architecture: any
Depends:
 libyuv0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (utilities)
 ${source:Extended-Description}
 .
 This package provides utilities provided by the library, including
 yuvconvert.

Package: libyuv0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 libyuv,
Conflicts:
 libyuv,
Replaces:
 libyuv,
Description: ${source:Synopsis} (shared library)
 ${source:Extended-Description}
 .
 This package provides the shared library.

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,11 @@
 #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # package maintainers to append LDFLAGS
 export DEB_LDFLAGS_MAINT_APPEND =
+
+# m-privacy
+export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
+export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
+export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
 
 %:
 	dh $@ --buildsystem=cmake
@@ -26,7 +31,8 @@
 endif
 
 # Known broken googletest
-ifneq (,$(filter $(DEB_HOST_ARCH), armel s390x powerpc ppc64 sparc64))
+# hppa: requested in https://bugs.debian.org/1021606
+ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa s390x powerpc ppc64 sparc64))
   LIBYUV_TEST_FLAG = OFF
 endif
 
@@ -41,3 +47,7 @@
 	-find . -name libyuv_unittest
 	( exec $$(find . -name libyuv_unittest) )
 endif
+
+override_dh_compress:
+	mp_rsbac
+	dh_compress

## libyuv 0.0.1898.20241125

=== debian/changelog ===
libyuv (0.0.1898.20241125-1) unstable; urgency=medium

  * New upstream snapshot.
  * debian/libyuv0.shlibs: Bump minimum required version.

 -- Boyuan Yang <byang@debian.org>  Tue, 26 Nov 2024 18:38:44 -0500

=== debian/watch ===
version=4
#opts="mode=git,pretty=0.0.%cd.%h" \
opts="mode=git,pretty=0.0.1898.%cd" \
 https://chromium.googlesource.com/libyuv/libyuv \
 HEAD debian uupdate
